InfoGrab Docs

취약점 아카이브 내보내기 API

요약

취약점 아카이브 내보내기에 대한 모든 API 호출은 인증이 필요합니다. 지정된 프로젝트에서 아카이브된 취약점에 대한 내보내기를 만듭니다. 인증된 사용자에게 취약점 읽기 권한이 없으면 이 요청은 403 Forbidden 상태 코드를 반환합니다.

취약점 아카이브 내보내기에 대한 모든 API 호출은 인증이 필요합니다.

아카이브된 취약점 내보내기 만들기#

지정된 프로젝트에서 아카이브된 취약점에 대한 내보내기를 만듭니다.

인증된 사용자에게 취약점 읽기 권한이 없으면 이 요청은 403 Forbidden 상태 코드를 반환합니다.

내보내기는 생성 후 1개월 동안 보관됩니다.

POST /security/projects/:id/vulnerability_archive_exports
속성 유형 필수 설명
id integer 또는 string 인증된 사용자가 구성원인 프로젝트의 ID 또는 URL 인코딩된 경로.
start_date string dd/mm/yyyy 형식의 날짜. 이 날짜 이후에 아카이브된 취약점이 내보내기에 포함됩니다.
end_date string dd/mm/yyyy 형식의 날짜. 이 날짜 이전에 아카이브된 취약점이 내보내기에 포함됩니다.
export_format string 아니오 내보내기 형식. 기본값이자 유일하게 유효한 값은 csv입니다.
curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/security/projects/1/vulnerability_archive_exports"

응답 예시:

{
  "id": 2,
  "created_at": "2020-03-30T09:35:38.746Z",
  "project_id": 1,
  "format": "csv",
  "status": "created",
  "started_at": null,
  "finished_at": null,
  "_links": {
    "self": "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2",
    "download": "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2/download"
  }
}

취약점 아카이브 내보내기 조회#

지정된 취약점 아카이브 내보내기의 속성을 조회합니다. 이 엔드포인트를 사용하여 내보내기 상태가 finished가 될 때까지 폴링할 수 있습니다. 클라이언트는 Poll-Interval 응답 헤더를 사용하여 다음 폴링을 보내기 전에 얼마나 기다려야 하는지 결정해야 합니다. Poll-Interval은 밀리초 단위의 시간을 나타내는 숫자입니다.

내보내기는 다음 상태 값을 가질 수 있습니다:

상태 설명
created 내보내기가 아직 실행되지 않았습니다.
running 내보내기가 생성 중입니다.
finished 내보내기를 이제 다운로드할 수 있습니다.
failed 내보내기 생성 중 오류가 발생하여 완료할 수 없었습니다.
purged 내보내기가 삭제 대기 중이며 파일을 더 이상 다운로드할 수 없습니다.
GET /security/vulnerability_archive_exports/:id
속성 유형 필수 설명
id integer 또는 string 취약점 아카이브 내보내기의 ID
curl --request GET \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2"

취약점 내보내기가 완료되지 않은 경우 응답은 202 Accepted입니다.

응답 예시:

{
  "id": 2,
  "created_at": "2020-03-30T09:35:38.746Z",
  "project_id": 1,
  "format": "csv",
  "status": "running",
  "started_at": "2020-03-30T09:38:24Z",
  "finished_at": null,
  "_links": {
    "self": "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2",
    "download": "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2/download"
  }
}

취약점 아카이브 내보내기 다운로드#

완료된 내보내기에 대한 내보내기 파일을 다운로드합니다. 이 엔드포인트를 호출하기 전에 내보내기 상태가 finished인지 확인하세요.

GET /security/vulnerability_archive_exports/:id/download
속성 유형 필수 설명
id integer 또는 string 취약점 내보내기의 ID
curl --request GET \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --output export.csv \
  --url "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2/download"

취약점 내보내기가 아직 완료되지 않았거나 찾을 수 없는 경우 응답은 404 Not Found입니다.

응답 예시:

Group Name,Project Name,Tool,Scanner Name,Status,Vulnerability,Details,Additional Info,Severity,CVE,CWE,Other Identifiers,Detected At,Location,Activity,Comments,Full Path,CVSS Vectors,Dismissal Reason
Gitlab.org,Defend,container_scanning,Trivy,resolved,CVE-2019-14697 in musl-utils-1.1.20-r4,"musl libc through 1.1.23 has an x87 floating-point stack adjustment imbalance, related to the math/i386/ directory. In some cases, use of this library could introduce out-of-bounds writes that are not present in an application's source code.",CVE-2019-14697 in musl-utils-1.1.20-r4,critical,CVE-2019-14697,,"",2022-10-07 13:34:41 UTC,"{""image""=>""python:3.4-alpine"", ""dependency""=>{""package""=>{""name""=>""musl-utils""}, ""version""=>""1.1.20-r4""}, ""operating_system""=>""alpine 3.9.2""}",true,"2022-10-07 13:41:08 UTC|root|resolved|changed vulnerability status to resolved",group/project/1,,,
Gitlab.org,Defend,container_scanning,Trivy,detected,CVE-2019-19242 in sqlite-libs-3.26.0-r3,"SQLite 3.30.1 mishandles pExpr->y.pTab, as demonstrated by the TK_COLUMN case in sqlite3ExprCodeTarget in expr.c.",CVE-2019-19242 in sqlite-libs-3.26.0-r3,medium,CVE-2019-19242,,"",2022-10-07 13:34:41 UTC,"{""image""=>""python:3.4-alpine"", ""dependency""=>{""package""=>{""name""=>""sqlite-libs""}, ""version""=>""3.26.0-r3""}, ""operating_system""=>""alpine 3.9.2""}",true,"",group/project/2,,,
Gitlab.org,Defend,container_scanning,Trivy,detected,CVE-2020-28928 in musl-1.1.20-r4,"In musl libc through 1.2.1, wcsnrtombs mishandles particular combinations of destination buffer size and source character limit, as demonstrated by an invalid write access (buffer overflow).",CVE-2020-28928 in musl-1.1.20-r4,medium,CVE-2020-28928,,"",2022-10-07 13:34:41 UTC,"{""image""=>""python:3.4-alpine"", ""dependency""=>{""package""=>{""name""=>""musl""}, ""version""=>""1.1.20-r4""}, ""operating_system""=>""alpine 3.9.2""}",true,"",group/project/3,,,
Gitlab.org,Defend,dependency_scanning,Gemnasium,detected,Improper Neutralization of Special Elements used in an OS Command ('OS Command Injection') in rack,Carefully crafted requests can cause shell escape sequences to be written to the terminal via Rack's Lint middleware and CommonLogger middleware. These escape sequences can be leveraged to possibly execute commands in the victim's terminal.,Improper Neutralization of Special Elements used in an OS Command ('OS Command Injection') in rack,unknown,Gemfile.lock:rack:gemnasium:60b5a27f-4e4d-4ab4-8ae7-74b4b212e177,,Gemnasium-60b5a27f-4e4d-4ab4-8ae7-74b4b212e177; GHSA-wq4h-7r42-5hrr,2022-10-14 13:16:00 UTC,"{""file""=>""Gemfile.lock"", ""dependency""=>{""package""=>{""name""=>""rack""}, ""version""=>""2.2.3""}}",false,group/project/4,,,
Gitlab.org,Defend,dependency_scanning,Gemnasium,detected,Denial of Service Vulnerability in Rack Multipart Parsing in rack,"Carefully crafted multipart POST requests can cause Rack's multipart parser to take much longer than expected, leading to a possible denial of service vulnerability. Impacted code will use Rack's multipart parser to parse multipart posts.",Denial of Service Vulnerability in Rack Multipart Parsing in rack,unknown,Gemfile.lock:rack:gemnasium:20daa17a-47b5-4f79-80c2-cd8f2db9805c,,Gemnasium-20daa17a-47b5-4f79-80c2-cd8f2db9805c; GHSA-hxqx-xwvh-44m2,2022-10-14 13:16:00 UTC,"{""file""=>""Gemfile.lock"", ""dependency""=>{""package""=>{""name""=>""rack""}, ""version""=>""2.2.3""}}",false,group/project/5,,,
Gitlab.org,Defend,sast,Brakeman,detected,Possible SQL injection,,Possible SQL injection,medium,e52f23a259cd489168b4313317ac94a3f13bffde57b9635171c1a44a9f329e9a,,"""Brakeman Warning Code 0""",2022-10-13 15:16:36 UTC,"{""file""=>""main.rb"", ""class""=>""User"", ""method""=>""index"", ""start_line""=>3}",false,"",group/project/6,,,
Gitlab.org,Defend,sast,Semgrep,dismissed,Improper Neutralization of Special Elements used in an SQL Command ('SQL Injection'),"SQL Injection is a critical vulnerability that can lead to data or system compromise...",,critical,,CWE-89,SCS0002,2023-12-28 10:48:34 UTC,"{""file""=>""WebGoat/App_Code/DB/SqliteDbProvider.cs"", ""start_line""=>274}",false,"2023-12-28 10:51:32 UTC|root|Dismissed|""changed vulnerability status to Dismissed: Not Applicable and the following comment: ""dismiss 5""",gitlab-org/defend/579,,Not applicable,

취약점 아카이브 내보내기 API

Tier: Ultimate
Offering: GitLab.com, GitLab Self-Managed, GitLab Dedicated
원문 보기
요약

취약점 아카이브 내보내기에 대한 모든 API 호출은 인증이 필요합니다. 지정된 프로젝트에서 아카이브된 취약점에 대한 내보내기를 만듭니다. 인증된 사용자에게 취약점 읽기 권한이 없으면 이 요청은 403 Forbidden 상태 코드를 반환합니다.

취약점 아카이브 내보내기에 대한 모든 API 호출은 인증이 필요합니다.

아카이브된 취약점 내보내기 만들기#

지정된 프로젝트에서 아카이브된 취약점에 대한 내보내기를 만듭니다.

인증된 사용자에게 취약점 읽기 권한이 없으면 이 요청은 403 Forbidden 상태 코드를 반환합니다.

내보내기는 생성 후 1개월 동안 보관됩니다.

POST /security/projects/:id/vulnerability_archive_exports
속성 유형 필수 설명
id integer 또는 string 인증된 사용자가 구성원인 프로젝트의 ID 또는 URL 인코딩된 경로.
start_date string dd/mm/yyyy 형식의 날짜. 이 날짜 이후에 아카이브된 취약점이 내보내기에 포함됩니다.
end_date string dd/mm/yyyy 형식의 날짜. 이 날짜 이전에 아카이브된 취약점이 내보내기에 포함됩니다.
export_format string 아니오 내보내기 형식. 기본값이자 유일하게 유효한 값은 csv입니다.
curl --request POST \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/security/projects/1/vulnerability_archive_exports"

응답 예시:

{
  "id": 2,
  "created_at": "2020-03-30T09:35:38.746Z",
  "project_id": 1,
  "format": "csv",
  "status": "created",
  "started_at": null,
  "finished_at": null,
  "_links": {
    "self": "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2",
    "download": "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2/download"
  }
}

취약점 아카이브 내보내기 조회#

지정된 취약점 아카이브 내보내기의 속성을 조회합니다. 이 엔드포인트를 사용하여 내보내기 상태가 finished가 될 때까지 폴링할 수 있습니다. 클라이언트는 Poll-Interval 응답 헤더를 사용하여 다음 폴링을 보내기 전에 얼마나 기다려야 하는지 결정해야 합니다. Poll-Interval은 밀리초 단위의 시간을 나타내는 숫자입니다.

내보내기는 다음 상태 값을 가질 수 있습니다:

상태 설명
created 내보내기가 아직 실행되지 않았습니다.
running 내보내기가 생성 중입니다.
finished 내보내기를 이제 다운로드할 수 있습니다.
failed 내보내기 생성 중 오류가 발생하여 완료할 수 없었습니다.
purged 내보내기가 삭제 대기 중이며 파일을 더 이상 다운로드할 수 없습니다.
GET /security/vulnerability_archive_exports/:id
속성 유형 필수 설명
id integer 또는 string 취약점 아카이브 내보내기의 ID
curl --request GET \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --url "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2"

취약점 내보내기가 완료되지 않은 경우 응답은 202 Accepted입니다.

응답 예시:

{
  "id": 2,
  "created_at": "2020-03-30T09:35:38.746Z",
  "project_id": 1,
  "format": "csv",
  "status": "running",
  "started_at": "2020-03-30T09:38:24Z",
  "finished_at": null,
  "_links": {
    "self": "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2",
    "download": "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2/download"
  }
}

취약점 아카이브 내보내기 다운로드#

완료된 내보내기에 대한 내보내기 파일을 다운로드합니다. 이 엔드포인트를 호출하기 전에 내보내기 상태가 finished인지 확인하세요.

GET /security/vulnerability_archive_exports/:id/download
속성 유형 필수 설명
id integer 또는 string 취약점 내보내기의 ID
curl --request GET \
  --header "PRIVATE-TOKEN: <your_access_token>" \
  --output export.csv \
  --url "https://gitlab.example.com/api/v4/security/vulnerability_archive_exports/2/download"

취약점 내보내기가 아직 완료되지 않았거나 찾을 수 없는 경우 응답은 404 Not Found입니다.

응답 예시:

Group Name,Project Name,Tool,Scanner Name,Status,Vulnerability,Details,Additional Info,Severity,CVE,CWE,Other Identifiers,Detected At,Location,Activity,Comments,Full Path,CVSS Vectors,Dismissal Reason
Gitlab.org,Defend,container_scanning,Trivy,resolved,CVE-2019-14697 in musl-utils-1.1.20-r4,"musl libc through 1.1.23 has an x87 floating-point stack adjustment imbalance, related to the math/i386/ directory. In some cases, use of this library could introduce out-of-bounds writes that are not present in an application's source code.",CVE-2019-14697 in musl-utils-1.1.20-r4,critical,CVE-2019-14697,,"",2022-10-07 13:34:41 UTC,"{""image""=>""python:3.4-alpine"", ""dependency""=>{""package""=>{""name""=>""musl-utils""}, ""version""=>""1.1.20-r4""}, ""operating_system""=>""alpine 3.9.2""}",true,"2022-10-07 13:41:08 UTC|root|resolved|changed vulnerability status to resolved",group/project/1,,,
Gitlab.org,Defend,container_scanning,Trivy,detected,CVE-2019-19242 in sqlite-libs-3.26.0-r3,"SQLite 3.30.1 mishandles pExpr->y.pTab, as demonstrated by the TK_COLUMN case in sqlite3ExprCodeTarget in expr.c.",CVE-2019-19242 in sqlite-libs-3.26.0-r3,medium,CVE-2019-19242,,"",2022-10-07 13:34:41 UTC,"{""image""=>""python:3.4-alpine"", ""dependency""=>{""package""=>{""name""=>""sqlite-libs""}, ""version""=>""3.26.0-r3""}, ""operating_system""=>""alpine 3.9.2""}",true,"",group/project/2,,,
Gitlab.org,Defend,container_scanning,Trivy,detected,CVE-2020-28928 in musl-1.1.20-r4,"In musl libc through 1.2.1, wcsnrtombs mishandles particular combinations of destination buffer size and source character limit, as demonstrated by an invalid write access (buffer overflow).",CVE-2020-28928 in musl-1.1.20-r4,medium,CVE-2020-28928,,"",2022-10-07 13:34:41 UTC,"{""image""=>""python:3.4-alpine"", ""dependency""=>{""package""=>{""name""=>""musl""}, ""version""=>""1.1.20-r4""}, ""operating_system""=>""alpine 3.9.2""}",true,"",group/project/3,,,
Gitlab.org,Defend,dependency_scanning,Gemnasium,detected,Improper Neutralization of Special Elements used in an OS Command ('OS Command Injection') in rack,Carefully crafted requests can cause shell escape sequences to be written to the terminal via Rack's Lint middleware and CommonLogger middleware. These escape sequences can be leveraged to possibly execute commands in the victim's terminal.,Improper Neutralization of Special Elements used in an OS Command ('OS Command Injection') in rack,unknown,Gemfile.lock:rack:gemnasium:60b5a27f-4e4d-4ab4-8ae7-74b4b212e177,,Gemnasium-60b5a27f-4e4d-4ab4-8ae7-74b4b212e177; GHSA-wq4h-7r42-5hrr,2022-10-14 13:16:00 UTC,"{""file""=>""Gemfile.lock"", ""dependency""=>{""package""=>{""name""=>""rack""}, ""version""=>""2.2.3""}}",false,group/project/4,,,
Gitlab.org,Defend,dependency_scanning,Gemnasium,detected,Denial of Service Vulnerability in Rack Multipart Parsing in rack,"Carefully crafted multipart POST requests can cause Rack's multipart parser to take much longer than expected, leading to a possible denial of service vulnerability. Impacted code will use Rack's multipart parser to parse multipart posts.",Denial of Service Vulnerability in Rack Multipart Parsing in rack,unknown,Gemfile.lock:rack:gemnasium:20daa17a-47b5-4f79-80c2-cd8f2db9805c,,Gemnasium-20daa17a-47b5-4f79-80c2-cd8f2db9805c; GHSA-hxqx-xwvh-44m2,2022-10-14 13:16:00 UTC,"{""file""=>""Gemfile.lock"", ""dependency""=>{""package""=>{""name""=>""rack""}, ""version""=>""2.2.3""}}",false,group/project/5,,,
Gitlab.org,Defend,sast,Brakeman,detected,Possible SQL injection,,Possible SQL injection,medium,e52f23a259cd489168b4313317ac94a3f13bffde57b9635171c1a44a9f329e9a,,"""Brakeman Warning Code 0""",2022-10-13 15:16:36 UTC,"{""file""=>""main.rb"", ""class""=>""User"", ""method""=>""index"", ""start_line""=>3}",false,"",group/project/6,,,
Gitlab.org,Defend,sast,Semgrep,dismissed,Improper Neutralization of Special Elements used in an SQL Command ('SQL Injection'),"SQL Injection is a critical vulnerability that can lead to data or system compromise...",,critical,,CWE-89,SCS0002,2023-12-28 10:48:34 UTC,"{""file""=>""WebGoat/App_Code/DB/SqliteDbProvider.cs"", ""start_line""=>274}",false,"2023-12-28 10:51:32 UTC|root|Dismissed|""changed vulnerability status to Dismissed: Not Applicable and the following comment: ""dismiss 5""",gitlab-org/defend/579,,Not applicable,